# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.AdSenseHost.V41.Model.AdUnit do
  @moduledoc """


  ## Attributes

  - code (String.t): Identity code of this ad unit, not necessarily unique across ad clients. Defaults to `nil`.
  - contentAdsSettings (GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings.t): Settings specific to content ads (AFC) and highend mobile content ads (AFMC - deprecated). Defaults to `nil`.
  - customStyle (GoogleApi.AdSenseHost.V41.Model.AdStyle.t): Custom style information specific to this ad unit. Defaults to `nil`.
  - id (String.t): Unique identifier of this ad unit. This should be considered an opaque identifier; it is not safe to rely on it being in any particular format. Defaults to `nil`.
  - kind (String.t): Kind of resource this is, in this case adsensehost#adUnit. Defaults to `adsensehost#adUnit`.
  - mobileContentAdsSettings (GoogleApi.AdSenseHost.V41.Model.AdUnitMobileContentAdsSettings.t): Settings specific to WAP mobile content ads (AFMC - deprecated). Defaults to `nil`.
  - name (String.t): Name of this ad unit. Defaults to `nil`.
  - status (String.t): Status of this ad unit. Possible values are:
  NEW: Indicates that the ad unit was created within the last seven days and does not yet have any activity associated with it.

  ACTIVE: Indicates that there has been activity on this ad unit in the last seven days.

  INACTIVE: Indicates that there has been no activity on this ad unit in the last seven days. Defaults to `nil`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :code => String.t(),
          :contentAdsSettings => GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings.t(),
          :customStyle => GoogleApi.AdSenseHost.V41.Model.AdStyle.t(),
          :id => String.t(),
          :kind => String.t(),
          :mobileContentAdsSettings =>
            GoogleApi.AdSenseHost.V41.Model.AdUnitMobileContentAdsSettings.t(),
          :name => String.t(),
          :status => String.t()
        }

  field(:code)
  field(:contentAdsSettings, as: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings)
  field(:customStyle, as: GoogleApi.AdSenseHost.V41.Model.AdStyle)
  field(:id)
  field(:kind)

  field(
    :mobileContentAdsSettings,
    as: GoogleApi.AdSenseHost.V41.Model.AdUnitMobileContentAdsSettings
  )

  field(:name)
  field(:status)
end

defimpl Poison.Decoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnit do
  def decode(value, options) do
    GoogleApi.AdSenseHost.V41.Model.AdUnit.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnit do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
