# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings do
  @moduledoc """
  Settings specific to content ads (AFC) and highend mobile content ads (AFMC - deprecated).

  ## Attributes

  - backupOption (GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption.t): The backup option to be used in instances where no ad is available. Defaults to `nil`.
  - size (String.t): Size of this ad unit. Size values are in the form SIZE_{width}_{height}. Defaults to `nil`.
  - type (String.t): Type of this ad unit. Possible values are TEXT, TEXT_IMAGE, IMAGE and LINK. Defaults to `nil`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :backupOption =>
            GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption.t(),
          :size => String.t(),
          :type => String.t()
        }

  field(:backupOption, as: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption)
  field(:size)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings do
  def decode(value, options) do
    GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
